(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('echarts'), require('vue')) :
  typeof define === 'function' && define.amd ? define(['echarts', 'vue'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, global.imoocDatav = factory(global.echarts, global.Vue));
})(this, (function (echarts, vue) { 'use strict';

  function _interopNamespace(e) {
    if (e && e.__esModule) return e;
    var n = Object.create(null);
    if (e) {
      Object.keys(e).forEach(function (k) {
        if (k !== 'default') {
          var d = Object.getOwnPropertyDescriptor(e, k);
          Object.defineProperty(n, k, d.get ? d : {
            enumerable: true,
            get: function () { return e[k]; }
          });
        }
      });
    }
    n["default"] = e;
    return Object.freeze(n);
  }

  var echarts__namespace = /*#__PURE__*/_interopNamespace(echarts);

  function _regeneratorRuntime() {
    _regeneratorRuntime = function () {
      return exports;
    };
    var exports = {},
      Op = Object.prototype,
      hasOwn = Op.hasOwnProperty,
      defineProperty = Object.defineProperty || function (obj, key, desc) {
        obj[key] = desc.value;
      },
      $Symbol = "function" == typeof Symbol ? Symbol : {},
      iteratorSymbol = $Symbol.iterator || "@@iterator",
      asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator",
      toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";
    function define(obj, key, value) {
      return Object.defineProperty(obj, key, {
        value: value,
        enumerable: !0,
        configurable: !0,
        writable: !0
      }), obj[key];
    }
    try {
      define({}, "");
    } catch (err) {
      define = function (obj, key, value) {
        return obj[key] = value;
      };
    }
    function wrap(innerFn, outerFn, self, tryLocsList) {
      var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator,
        generator = Object.create(protoGenerator.prototype),
        context = new Context(tryLocsList || []);
      return defineProperty(generator, "_invoke", {
        value: makeInvokeMethod(innerFn, self, context)
      }), generator;
    }
    function tryCatch(fn, obj, arg) {
      try {
        return {
          type: "normal",
          arg: fn.call(obj, arg)
        };
      } catch (err) {
        return {
          type: "throw",
          arg: err
        };
      }
    }
    exports.wrap = wrap;
    var ContinueSentinel = {};
    function Generator() {}
    function GeneratorFunction() {}
    function GeneratorFunctionPrototype() {}
    var IteratorPrototype = {};
    define(IteratorPrototype, iteratorSymbol, function () {
      return this;
    });
    var getProto = Object.getPrototypeOf,
      NativeIteratorPrototype = getProto && getProto(getProto(values([])));
    NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol) && (IteratorPrototype = NativeIteratorPrototype);
    var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);
    function defineIteratorMethods(prototype) {
      ["next", "throw", "return"].forEach(function (method) {
        define(prototype, method, function (arg) {
          return this._invoke(method, arg);
        });
      });
    }
    function AsyncIterator(generator, PromiseImpl) {
      function invoke(method, arg, resolve, reject) {
        var record = tryCatch(generator[method], generator, arg);
        if ("throw" !== record.type) {
          var result = record.arg,
            value = result.value;
          return value && "object" == typeof value && hasOwn.call(value, "__await") ? PromiseImpl.resolve(value.__await).then(function (value) {
            invoke("next", value, resolve, reject);
          }, function (err) {
            invoke("throw", err, resolve, reject);
          }) : PromiseImpl.resolve(value).then(function (unwrapped) {
            result.value = unwrapped, resolve(result);
          }, function (error) {
            return invoke("throw", error, resolve, reject);
          });
        }
        reject(record.arg);
      }
      var previousPromise;
      defineProperty(this, "_invoke", {
        value: function (method, arg) {
          function callInvokeWithMethodAndArg() {
            return new PromiseImpl(function (resolve, reject) {
              invoke(method, arg, resolve, reject);
            });
          }
          return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
        }
      });
    }
    function makeInvokeMethod(innerFn, self, context) {
      var state = "suspendedStart";
      return function (method, arg) {
        if ("executing" === state) throw new Error("Generator is already running");
        if ("completed" === state) {
          if ("throw" === method) throw arg;
          return doneResult();
        }
        for (context.method = method, context.arg = arg;;) {
          var delegate = context.delegate;
          if (delegate) {
            var delegateResult = maybeInvokeDelegate(delegate, context);
            if (delegateResult) {
              if (delegateResult === ContinueSentinel) continue;
              return delegateResult;
            }
          }
          if ("next" === context.method) context.sent = context._sent = context.arg;else if ("throw" === context.method) {
            if ("suspendedStart" === state) throw state = "completed", context.arg;
            context.dispatchException(context.arg);
          } else "return" === context.method && context.abrupt("return", context.arg);
          state = "executing";
          var record = tryCatch(innerFn, self, context);
          if ("normal" === record.type) {
            if (state = context.done ? "completed" : "suspendedYield", record.arg === ContinueSentinel) continue;
            return {
              value: record.arg,
              done: context.done
            };
          }
          "throw" === record.type && (state = "completed", context.method = "throw", context.arg = record.arg);
        }
      };
    }
    function maybeInvokeDelegate(delegate, context) {
      var methodName = context.method,
        method = delegate.iterator[methodName];
      if (undefined === method) return context.delegate = null, "throw" === methodName && delegate.iterator.return && (context.method = "return", context.arg = undefined, maybeInvokeDelegate(delegate, context), "throw" === context.method) || "return" !== methodName && (context.method = "throw", context.arg = new TypeError("The iterator does not provide a '" + methodName + "' method")), ContinueSentinel;
      var record = tryCatch(method, delegate.iterator, context.arg);
      if ("throw" === record.type) return context.method = "throw", context.arg = record.arg, context.delegate = null, ContinueSentinel;
      var info = record.arg;
      return info ? info.done ? (context[delegate.resultName] = info.value, context.next = delegate.nextLoc, "return" !== context.method && (context.method = "next", context.arg = undefined), context.delegate = null, ContinueSentinel) : info : (context.method = "throw", context.arg = new TypeError("iterator result is not an object"), context.delegate = null, ContinueSentinel);
    }
    function pushTryEntry(locs) {
      var entry = {
        tryLoc: locs[0]
      };
      1 in locs && (entry.catchLoc = locs[1]), 2 in locs && (entry.finallyLoc = locs[2], entry.afterLoc = locs[3]), this.tryEntries.push(entry);
    }
    function resetTryEntry(entry) {
      var record = entry.completion || {};
      record.type = "normal", delete record.arg, entry.completion = record;
    }
    function Context(tryLocsList) {
      this.tryEntries = [{
        tryLoc: "root"
      }], tryLocsList.forEach(pushTryEntry, this), this.reset(!0);
    }
    function values(iterable) {
      if (iterable) {
        var iteratorMethod = iterable[iteratorSymbol];
        if (iteratorMethod) return iteratorMethod.call(iterable);
        if ("function" == typeof iterable.next) return iterable;
        if (!isNaN(iterable.length)) {
          var i = -1,
            next = function next() {
              for (; ++i < iterable.length;) if (hasOwn.call(iterable, i)) return next.value = iterable[i], next.done = !1, next;
              return next.value = undefined, next.done = !0, next;
            };
          return next.next = next;
        }
      }
      return {
        next: doneResult
      };
    }
    function doneResult() {
      return {
        value: undefined,
        done: !0
      };
    }
    return GeneratorFunction.prototype = GeneratorFunctionPrototype, defineProperty(Gp, "constructor", {
      value: GeneratorFunctionPrototype,
      configurable: !0
    }), defineProperty(GeneratorFunctionPrototype, "constructor", {
      value: GeneratorFunction,
      configurable: !0
    }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction"), exports.isGeneratorFunction = function (genFun) {
      var ctor = "function" == typeof genFun && genFun.constructor;
      return !!ctor && (ctor === GeneratorFunction || "GeneratorFunction" === (ctor.displayName || ctor.name));
    }, exports.mark = function (genFun) {
      return Object.setPrototypeOf ? Object.setPrototypeOf(genFun, GeneratorFunctionPrototype) : (genFun.__proto__ = GeneratorFunctionPrototype, define(genFun, toStringTagSymbol, "GeneratorFunction")), genFun.prototype = Object.create(Gp), genFun;
    }, exports.awrap = function (arg) {
      return {
        __await: arg
      };
    }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, asyncIteratorSymbol, function () {
      return this;
    }), exports.AsyncIterator = AsyncIterator, exports.async = function (innerFn, outerFn, self, tryLocsList, PromiseImpl) {
      void 0 === PromiseImpl && (PromiseImpl = Promise);
      var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList), PromiseImpl);
      return exports.isGeneratorFunction(outerFn) ? iter : iter.next().then(function (result) {
        return result.done ? result.value : iter.next();
      });
    }, defineIteratorMethods(Gp), define(Gp, toStringTagSymbol, "Generator"), define(Gp, iteratorSymbol, function () {
      return this;
    }), define(Gp, "toString", function () {
      return "[object Generator]";
    }), exports.keys = function (val) {
      var object = Object(val),
        keys = [];
      for (var key in object) keys.push(key);
      return keys.reverse(), function next() {
        for (; keys.length;) {
          var key = keys.pop();
          if (key in object) return next.value = key, next.done = !1, next;
        }
        return next.done = !0, next;
      };
    }, exports.values = values, Context.prototype = {
      constructor: Context,
      reset: function (skipTempReset) {
        if (this.prev = 0, this.next = 0, this.sent = this._sent = undefined, this.done = !1, this.delegate = null, this.method = "next", this.arg = undefined, this.tryEntries.forEach(resetTryEntry), !skipTempReset) for (var name in this) "t" === name.charAt(0) && hasOwn.call(this, name) && !isNaN(+name.slice(1)) && (this[name] = undefined);
      },
      stop: function () {
        this.done = !0;
        var rootRecord = this.tryEntries[0].completion;
        if ("throw" === rootRecord.type) throw rootRecord.arg;
        return this.rval;
      },
      dispatchException: function (exception) {
        if (this.done) throw exception;
        var context = this;
        function handle(loc, caught) {
          return record.type = "throw", record.arg = exception, context.next = loc, caught && (context.method = "next", context.arg = undefined), !!caught;
        }
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i],
            record = entry.completion;
          if ("root" === entry.tryLoc) return handle("end");
          if (entry.tryLoc <= this.prev) {
            var hasCatch = hasOwn.call(entry, "catchLoc"),
              hasFinally = hasOwn.call(entry, "finallyLoc");
            if (hasCatch && hasFinally) {
              if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
              if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
            } else if (hasCatch) {
              if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
            } else {
              if (!hasFinally) throw new Error("try statement without catch or finally");
              if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
            }
          }
        }
      },
      abrupt: function (type, arg) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
            var finallyEntry = entry;
            break;
          }
        }
        finallyEntry && ("break" === type || "continue" === type) && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc && (finallyEntry = null);
        var record = finallyEntry ? finallyEntry.completion : {};
        return record.type = type, record.arg = arg, finallyEntry ? (this.method = "next", this.next = finallyEntry.finallyLoc, ContinueSentinel) : this.complete(record);
      },
      complete: function (record, afterLoc) {
        if ("throw" === record.type) throw record.arg;
        return "break" === record.type || "continue" === record.type ? this.next = record.arg : "return" === record.type ? (this.rval = this.arg = record.arg, this.method = "return", this.next = "end") : "normal" === record.type && afterLoc && (this.next = afterLoc), ContinueSentinel;
      },
      finish: function (finallyLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          if (entry.finallyLoc === finallyLoc) return this.complete(entry.completion, entry.afterLoc), resetTryEntry(entry), ContinueSentinel;
        }
      },
      catch: function (tryLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          if (entry.tryLoc === tryLoc) {
            var record = entry.completion;
            if ("throw" === record.type) {
              var thrown = record.arg;
              resetTryEntry(entry);
            }
            return thrown;
          }
        }
        throw new Error("illegal catch attempt");
      },
      delegateYield: function (iterable, resultName, nextLoc) {
        return this.delegate = {
          iterator: values(iterable),
          resultName: resultName,
          nextLoc: nextLoc
        }, "next" === this.method && (this.arg = undefined), ContinueSentinel;
      }
    }, exports;
  }
  function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }
    if (info.done) {
      resolve(value);
    } else {
      Promise.resolve(value).then(_next, _throw);
    }
  }
  function _asyncToGenerator(fn) {
    return function () {
      var self = this,
        args = arguments;
      return new Promise(function (resolve, reject) {
        var gen = fn.apply(self, args);
        function _next(value) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
        }
        function _throw(err) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
        }
        _next(undefined);
      });
    };
  }

  var script$1 = {
    name: 'myText',
    props: {
      WidgetDefinition: {}
    },
    data: function data() {
      return {
        title: {
          text: this.WidgetDefinition.ChartName,
          //标题
          subtext: '',
          //副标题
          left: 'center' //对其方式
        },

        tooltip: {
          trigger: 'item',
          //触发类型 默认item
          axisPointer: {
            //坐标轴指示器，坐标轴触发有效，
            type: 'line',
            //默认为line，line直线，cross十字准星，shadow阴影
            formatter: '{a} <br/>{b} : {c}%'
          }
        },
        legend: {
          orient: 'vertical',
          left: 'left'
        },
        xAxis: {
          show: 'true',
          //是否显示x轴
          data: ['2-采购部', '1-质检部', '4-采购部', '1-采购部'],
          //设置X轴上的值
          boundaryGap: 'true',
          //x坐标轴两边留白策略默认为true，两边留白，false，两边不留白、或者['30%','20%']
          axisLabel: {
            interval: 0
          } //x轴的刻度以及一些参数的设置
        },

        yAxis: {},
        series: [],
        seriesData: {
          type: 'bar',
          // data: [4, 1, 4, 1, 0, 2, 5, 8],
          data: [{
            value: 1048,
            name: 'Search Engine'
          },
          //value--值 name--鼠标悬浮显示内容
          {
            value: 735,
            name: 'Direct'
          }, {
            value: 580,
            name: 'Email'
          }, {
            value: 484,
            name: 'Union Ads'
          }, {
            value: 300,
            name: 'Video Ads'
          }],
          radius: '50%',
          //图表大小
          stack: '' //堆叠 写入Search Engine
        },

        dataZoom: [{
          type: 'inside' //鼠标缩放
        }]
      };
    },
    mounted: function mounted() {
      this.GetOption();
    },
    methods: {
      GetOption: function GetOption() {
        var _this = this;
        return _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
          var that, url, params;
          return _regeneratorRuntime().wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  that = _this;
                  url = 'http://192.168.27.9:17003' + '/engine/report/data/v1/getAdvanceReportData';
                  params = {
                    aggregateFields: [{
                      aggregateFunction: _this.WidgetDefinition.Vertical,
                      field: _this.WidgetDefinition.YField
                    }],
                    codename: _this.WidgetDefinition.CodeName,
                    columns: [],
                    pagecode: _this.WidgetDefinition.PageCode,
                    rows: [_this.WidgetDefinition.XField]
                  };
                  fetch(url, {
                    method: 'post',
                    body: JSON.stringify(params),
                    headers: {
                      'Content-Type': 'application/json',
                      Authorization: 'admin@@7534e563-b70a-45c3-a0ba-be1f2f3bd303'
                    }
                  }).then(function (res) {
                    return res.json();
                  }).then(function (ret) {
                    if (ret.successful) {
                      ShowChart$1(that, ret.content); //图表展示
                    }
                  });
                case 4:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee);
        }))();
      }
    }
  };
  var ShowChart$1 = function ShowChart(that, res) {
    var myChart = echarts__namespace.init(document.getElementById('barchart'));
    var Option = {};
    switch (that.WidgetDefinition.WidgetType) {
      case '1': //柱状图
      case '2': //折线图
      case '3':
        //条形图
        that.seriesData.type = that.WidgetDefinition.WidgetType == 1 || that.WidgetDefinition.WidgetType == 3 ? 'bar' : 'line'; //图表类型
        if (that.WidgetDefinition.Stack && that.seriesData.type == 'bar') {
          that.seriesData.stack = 'Search Engine';
        } else if (that.WidgetDefinition.Stack && that.seriesData.type == 'line') {
          that.seriesData.stack = 'Total';
        } else {
          that.seriesData.stack = '';
        }
        console.log(that.seriesData);
        var xAxisData = [];
        var valueData = [];
        Object.keys(res.rows).forEach(function (row) {
          xAxisData.push(row);
          Object.keys(res.data).forEach(function (item) {
            if ('_' + row == item) {
              Object.keys(res.data[item]).forEach(function (da) {
                valueData.push(res.data[item][da]);
              });
            }
          });
        });
        that.xAxis.data = xAxisData; //获取X轴的值
        that.seriesData.data = valueData; //获取值
        that.series.push(that.seriesData);
        Option = {
          title: that.title,
          tooltip: that.tooltip,
          xAxis: that.WidgetDefinition.WidgetType == 3 ? that.yAxis : that.xAxis,
          yAxis: that.WidgetDefinition.WidgetType == 3 ? that.xAxis : that.yAxis,
          series: that.series,
          //数据
          dataZoom: that.dataZoom //缩放
        };

        myChart.setOption(Option);
        break;
      case '4':
        //饼图
        that.seriesData.type = 'pie';
        var valueData = [];
        Object.keys(res.rows).forEach(function (row) {
          Object.keys(res.data).forEach(function (item) {
            if ('_' + row == item) {
              Object.keys(res.data[item]).forEach(function (da) {
                var datas = {};
                datas.value = res.data[item][da];
                datas.name = row;
                valueData.push(datas);
              });
            }
          });
        });
        that.seriesData.data = valueData; //获取值
        that.series.push(that.seriesData);
        Option = {
          title: that.title,
          tooltip: that.tooltip,
          series: that.series,
          //数据
          dataZoom: that.dataZoom,
          //缩放
          legend: that.legend
        };
        myChart.setOption(Option);
        break;
      case '5':
        //漏斗图
        that.seriesData.type = 'funnel';
        var valueData = [];
        Object.keys(res.rows).forEach(function (row) {
          Object.keys(res.data).forEach(function (item) {
            if ('_' + row == item) {
              Object.keys(res.data[item]).forEach(function (da) {
                var datas = {};
                datas.value = res.data[item][da];
                datas.name = row;
                valueData.push(datas);
              });
            }
          });
        });
        that.seriesData.data = valueData; //获取值
        that.seriesData.left = '10%';
        that.seriesData.top = 60;
        that.seriesData.bottom = 60;
        that.seriesData.width = '80%';
        // that.seriesData.min = 0;
        // that.seriesData.max = 100;
        that.seriesData.minSize = '0%';
        that.seriesData.maxSize = '100%';
        that.seriesData.sort = 'descending';
        that.seriesData.label = {
          show: true,
          position: 'inside'
        };
        that.seriesData.labelLine = {
          length: 10,
          lineStyle: {
            width: 1,
            type: 'solid'
          }
        };
        that.seriesData.itemStyle = {
          borderColor: '#fff',
          borderWidth: 1
        };
        that.seriesData.emphasis = {
          label: {
            fontSize: 20
          }
        };
        that.series.push(that.seriesData);
    }
  };

  var _hoisted_1$1 = {
    "class": "Echarts"
  };
  var _hoisted_2 = /*#__PURE__*/vue.createElementVNode("div", {
    id: "barchart",
    style: {
      "width": "600px",
      "height": "400px"
    }
  }, null, -1 /* HOISTED */);
  var _hoisted_3 = [_hoisted_2];
  function render$1(_ctx, _cache, $props, $setup, $data, $options) {
    return vue.openBlock(), vue.createElementBlock("div", _hoisted_1$1, _hoisted_3);
  }

  script$1.render = render$1;
  script$1.__file = "src/components/myText/myText.vue";

  var getAdvanceReportData = /*#__PURE__*/function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(param, url, token) {
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return fetch(url + "/engine/report/data/v1/getAdvanceReportData", {
                method: "post",
                body: JSON.stringify(param),
                headers: {
                  "Content-Type": "application/json",
                  Authorization: token
                }
              });
            case 2:
              return _context.abrupt("return", _context.sent);
            case 3:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));
    return function getAdvanceReportData(_x, _x2, _x3) {
      return _ref.apply(this, arguments);
    };
  }();

  var script = {
    name: 'chartType',
    props: {
      WidgetDefinition: {},
      baseUrl: '',
      token: '',
      Dashboard: {}
    },
    data: function data() {
      return {
        title: {
          text: this.Dashboard.name,
          //标题
          subtext: '',
          //副标题
          left: 'center' //对其方式
        },

        tooltip: {
          trigger: 'item',
          //触发类型 默认item
          axisPointer: {
            //坐标轴指示器，坐标轴触发有效，
            type: 'line',
            //默认为line，line直线，cross十字准星，shadow阴影
            formatter: '{a} <br/>{b} : {c}%'
          }
        },
        legend: {
          orient: 'vertical',
          left: 'left'
        },
        xAxis: {
          show: 'true',
          //是否显示x轴
          data: [],
          //设置X轴上的值
          boundaryGap: 'true' //x坐标轴两边留白策略默认为true，两边留白，false，两边不留白、或者['30%','20%']
          // axisLabel: { interval: 0 }, //x轴的刻度以及一些参数的设置
        },

        yAxis: {},
        series: [],
        seriesData: {
          type: 'bar',
          data: [],
          radius: '50%',
          //图表大小
          stack: '' //堆叠
        },

        dataZoom: [{
          type: 'inside' //鼠标缩放
        }]
      };
    },
    mounted: function mounted() {
      var _this = this;
      return _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
        return _regeneratorRuntime().wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return _this.GetHtml();
              case 2:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }))();
    },
    methods: {
      GetHtml: function GetHtml() {
        var _this2 = this;
        return _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2() {
          var num, content, newElement, i, that, aggregateFields, params;
          return _regeneratorRuntime().wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  num = 0;
                  content = document.getElementById(_this2.myId);
                  newElement = document.createElement('div');
                  i = 0;
                case 4:
                  if (!(i < 99)) {
                    _context2.next = 14;
                    break;
                  }
                  if (!(document.getElementById('chart_' + _this2.WidgetDefinition.CodeName + num) == null)) {
                    _context2.next = 10;
                    break;
                  }
                  newElement.id = 'chart_' + _this2.WidgetDefinition.CodeName + num;
                  return _context2.abrupt("break", 14);
                case 10:
                  num++;
                case 11:
                  i++;
                  _context2.next = 4;
                  break;
                case 14:
                  newElement.style.width = '100%';
                  newElement.style.height = '400px';
                  newElement.style.margin = '0 auto';
                  newElement.style.border = '1px solid #DDD';
                  content.append(newElement);
                  that = _this2;
                  aggregateFields = [];
                  _this2.WidgetDefinition.YaxisData.forEach(function (element) {
                    var aggregate = {
                      aggregateFunction: _this2.WidgetDefinition.VerticalAxis,
                      field: element
                    };
                    aggregateFields.push(aggregate);
                  });
                  params = {
                    aggregateFields: aggregateFields,
                    codename: _this2.WidgetDefinition.CodeName,
                    columns: [],
                    pagecode: _this2.WidgetDefinition.PageCode,
                    rows: _this2.WidgetDefinition.XaxisData
                  };
                  _context2.next = 25;
                  return getAdvanceReportData(params, that.baseUrl, that.token).then(function (res) {
                    return res.json();
                  }).then(function (ret) {
                    if (ret.successful) {
                      ShowChart(that, ret.content, newElement.id); //图表展示
                    }
                  });
                case 25:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2);
        }))();
      }
    },
    computed: {
      myId: function myId() {
        return 'content' + Math.random() * 10;
      }
    }
  };
  var ShowChart = /*#__PURE__*/function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee3(that, res, id) {
      var myChart;
      return _regeneratorRuntime().wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              _context3.t0 = that.WidgetDefinition.WidgetType;
              _context3.next = _context3.t0 === '1' ? 3 : _context3.t0 === '2' ? 7 : _context3.t0 === '3' ? 11 : _context3.t0 === '4' ? 15 : _context3.t0 === '5' ? 19 : _context3.t0 === '6' ? 23 : _context3.t0 === '7' ? 27 : 31;
              break;
            case 3:
              //柱状图
              myChart = echarts__namespace.init(document.getElementById(id));
              _context3.next = 6;
              return chartbayorline(res.rows, res.data, that, myChart);
            case 6:
              return _context3.abrupt("break", 31);
            case 7:
              //折线图
              myChart = echarts__namespace.init(document.getElementById(id));
              _context3.next = 10;
              return chartbayorline(res.rows, res.data, that, myChart);
            case 10:
              return _context3.abrupt("break", 31);
            case 11:
              //条形图
              myChart = echarts__namespace.init(document.getElementById(id));
              _context3.next = 14;
              return chartbayorline(res.rows, res.data, that, myChart);
            case 14:
              return _context3.abrupt("break", 31);
            case 15:
              //饼图
              myChart = echarts__namespace.init(document.getElementById(id));
              _context3.next = 18;
              return chartPie(res.rows, res.data, that, myChart);
            case 18:
              return _context3.abrupt("break", 31);
            case 19:
              //漏斗图
              myChart = echarts__namespace.init(document.getElementById(id));
              _context3.next = 22;
              return chartFunnel(that, res, myChart);
            case 22:
              return _context3.abrupt("break", 31);
            case 23:
              //面积图
              myChart = echarts__namespace.init(document.getElementById(id));
              _context3.next = 26;
              return chartArea(res.rows, res.data, that, myChart);
            case 26:
              return _context3.abrupt("break", 31);
            case 27:
              //数字卡
              myChart = echarts__namespace.init(document.getElementById(id));
              _context3.next = 30;
              return numCard(res.data, that, myChart);
            case 30:
              return _context3.abrupt("break", 31);
            case 31:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }));
    return function ShowChart(_x, _x2, _x3) {
      return _ref.apply(this, arguments);
    };
  }();
  var Ydata = [];
  var chartbayorline = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee4(rows, data, that, myChart) {
      var Option;
      return _regeneratorRuntime().wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              Ydata = [];
              _context4.next = 3;
              return Object.keys(rows).forEach(function (rr) {
                if (JSON.stringify(rows[rr]) == '{}') {
                  that.xAxis.data.push(rr);
                  Object.keys(data).forEach(function (ff) {
                    if ('_' + rr == ff) {
                      Ydata.push(data[ff]);
                    }
                  });
                } else {
                  chartBarOrLineData(rows[rr], data, that, '_' + rr);
                }
              });
            case 3:
              _context4.next = 5;
              return that.WidgetDefinition.YaxisData.forEach(function (yy, index) {
                var seriesdata = {
                  type: that.WidgetDefinition.WidgetType == 1 || that.WidgetDefinition.WidgetType == 3 ? 'bar' : 'line',
                  stack: '',
                  name: '',
                  data: []
                };
                if (that.WidgetDefinition.Stack) {
                  seriesdata.stack = 'total';
                } else {
                  seriesdata.stack = '';
                }
                seriesdata.name = that.WidgetDefinition.YaxisValueData[index];
                var dt = that.WidgetDefinition.VerticalAxis.toUpperCase() + '_' + yy;
                Ydata.filter(function (f) {
                  seriesdata.data.push(f[dt]);
                });
                that.series.push(seriesdata);
              });
            case 5:
              Option = {
                title: that.title,
                tooltip: that.tooltip,
                xAxis: that.WidgetDefinition.WidgetType == 3 ? that.yAxis : that.xAxis,
                yAxis: that.WidgetDefinition.WidgetType == 3 ? that.xAxis : that.yAxis,
                series: that.series,
                //数据
                dataZoom: that.dataZoom //缩放
              };

              myChart.setOption(Option);
            case 7:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4);
    }));
    return function chartbayorline(_x4, _x5, _x6, _x7) {
      return _ref2.apply(this, arguments);
    };
  }();
  var chartBarOrLineData = /*#__PURE__*/function () {
    var _ref3 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee5(rows, data, that, dataname) {
      return _regeneratorRuntime().wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              if (JSON.stringify(rows) != '{}') {
                Object.keys(rows).forEach(function (ff) {
                  chartBarOrLineData(rows[ff], data, that, dataname + '.' + ff);
                });
              } else {
                that.xAxis.data.push(dataname);
                Object.keys(data).forEach(function (ff) {
                  if (dataname == ff) {
                    Ydata.push(data[ff]);
                  }
                });
              }
            case 1:
            case "end":
              return _context5.stop();
          }
        }
      }, _callee5);
    }));
    return function chartBarOrLineData(_x8, _x9, _x10, _x11) {
      return _ref3.apply(this, arguments);
    };
  }();
  var chartPie = /*#__PURE__*/function () {
    var _ref4 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee6(rows, data, that, myChart) {
      var Option;
      return _regeneratorRuntime().wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              Ydata = [];
              _context6.next = 3;
              return Object.keys(rows).forEach(function (rr) {
                if (JSON.stringify(rows[rr]) == '{}') {
                  that.xAxis.data.push(rr);
                  Object.keys(data).forEach(function (ff) {
                    if ('_' + rr == ff) {
                      var a = {};
                      a.data = data[ff];
                      a.name = ff;
                      Ydata.push(a);
                      // Ydata.push(data[ff]);
                    }
                  });
                } else {
                  chartPieData(rows[rr], data, that, '_' + rr);
                }
              });
            case 3:
              _context6.next = 5;
              return that.WidgetDefinition.YaxisData.forEach(function (yy, index) {
                var seriesdata = {
                  type: 'pie',
                  name: '',
                  radius: '50%',
                  data: []
                };
                seriesdata.name = that.WidgetDefinition.YaxisValueData[index];
                var dt = that.WidgetDefinition.VerticalAxis.toUpperCase() + '_' + yy;
                Ydata.filter(function (f) {
                  seriesdata.data.push({
                    value: f.data[dt],
                    name: f.name
                  });
                });
                that.series.push(seriesdata);
              });
            case 5:
              Option = {
                title: that.title,
                tooltip: that.tooltip,
                series: that.series,
                //数据
                dataZoom: that.dataZoom,
                //缩放
                legend: that.legend
              };
              myChart.setOption(Option);
            case 7:
            case "end":
              return _context6.stop();
          }
        }
      }, _callee6);
    }));
    return function chartPie(_x12, _x13, _x14, _x15) {
      return _ref4.apply(this, arguments);
    };
  }();
  var chartPieData = /*#__PURE__*/function () {
    var _ref5 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee7(rows, data, that, dataname) {
      return _regeneratorRuntime().wrap(function _callee7$(_context7) {
        while (1) {
          switch (_context7.prev = _context7.next) {
            case 0:
              if (JSON.stringify(rows) != '{}') {
                Object.keys(rows).forEach(function (ff) {
                  chartPieData(rows[ff], data, that, dataname + '.' + ff);
                });
              } else {
                that.xAxis.data.push(dataname);
                Object.keys(data).forEach(function (ff) {
                  if (dataname == ff) {
                    var a = {};
                    a.data = data[ff];
                    a.name = dataname;
                    Ydata.push(a);
                  }
                });
              }
            case 1:
            case "end":
              return _context7.stop();
          }
        }
      }, _callee7);
    }));
    return function chartPieData(_x16, _x17, _x18, _x19) {
      return _ref5.apply(this, arguments);
    };
  }();
  //暂时只支持单参数
  var chartFunnel = /*#__PURE__*/function () {
    var _ref6 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee8(that, res, myChart) {
      var valueData;
      return _regeneratorRuntime().wrap(function _callee8$(_context8) {
        while (1) {
          switch (_context8.prev = _context8.next) {
            case 0:
              that.seriesData.type = 'funnel';
              valueData = [];
              Object.keys(res.rows).forEach(function (row) {
                Object.keys(res.data).forEach(function (item) {
                  if ('_' + row == item) {
                    Object.keys(res.data[item]).forEach(function (da) {
                      var datas = {};
                      datas.value = res.data[item][da];
                      datas.name = row;
                      valueData.push(datas);
                    });
                  }
                });
              });
              that.seriesData.data = valueData; //获取值
              that.seriesData.left = '10%';
              that.seriesData.top = 60;
              that.seriesData.bottom = 60;
              that.seriesData.width = '80%';
              // that.seriesData.min = 0;
              // that.seriesData.max = 100;
              that.seriesData.minSize = '0%';
              that.seriesData.maxSize = '100%';
              that.seriesData.sort = 'descending';
              that.seriesData.label = {
                show: true,
                position: 'inside'
              };
              that.seriesData.labelLine = {
                length: 10,
                lineStyle: {
                  width: 1,
                  type: 'solid'
                }
              };
              that.seriesData.itemStyle = {
                borderColor: '#fff',
                borderWidth: 1
              };
              that.seriesData.emphasis = {
                label: {
                  fontSize: 20
                }
              };
              that.series.push(that.seriesData);
              Option = {
                title: that.title,
                tooltip: that.tooltip,
                series: that.series,
                //数据
                dataZoom: that.dataZoom //缩放
              };

              myChart.setOption(Option);
              // var seriesdata = {};
              // seriesdata.name = that.WidgetDefinition.ChartName;
              // seriesdata.type = "funnel";
              // seriesdata.width = "50%";
              // seriesdata.height = "45%";
              // seriesdata.left = "5%";
              // seriesdata.top = "50%";
              // seriesdata.data = [
              //   { value: 60, name: "Visit" },
              //   { value: 30, name: "Inquiry" },
              //   { value: 10, name: "Order" },
              //   { value: 80, name: "Click" },
              //   { value: 100, name: "Show" },
              // ];
              // that.series.push(seriesdata);
              // seriesdata = {};
              // seriesdata.name = that.WidgetDefinition.ChartName;
              // seriesdata.type = "funnel";
              // seriesdata.width = "50%";
              // seriesdata.height = "45%";
              // seriesdata.left = "5%";
              // seriesdata.top = "5%";
              // seriesdata.sort = "ascending";
              // seriesdata.data = [
              //   { value: 60, name: "Visit" },
              //   { value: 30, name: "Inquiry" },
              //   { value: 10, name: "Order" },
              //   { value: 80, name: "Click" },
              //   { value: 100, name: "Show" },
              // ];
              // that.series.push(seriesdata);
              // var Option = {
              //   title: that.title,
              //   tooltip: that.tooltip,
              //   series: that.series, //数据
              //   dataZoom: that.dataZoom, //缩放
              // };
              // myChart.setOption(Option);
            case 18:
            case "end":
              return _context8.stop();
          }
        }
      }, _callee8);
    }));
    return function chartFunnel(_x20, _x21, _x22) {
      return _ref6.apply(this, arguments);
    };
  }();
  var chartArea = /*#__PURE__*/function () {
    var _ref7 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee9(rows, data, that, myChart) {
      var Option;
      return _regeneratorRuntime().wrap(function _callee9$(_context9) {
        while (1) {
          switch (_context9.prev = _context9.next) {
            case 0:
              Ydata = [];
              _context9.next = 3;
              return Object.keys(rows).forEach(function (rr) {
                if (JSON.stringify(rows[rr]) == '{}') {
                  that.xAxis.data.push(rr);
                  Object.keys(data).forEach(function (ff) {
                    if ('_' + rr == ff) {
                      Ydata.push(data[ff]);
                    }
                  });
                } else {
                  chartAreaData(rows[rr], data, that, '_' + rr);
                }
              });
            case 3:
              that.WidgetDefinition.YaxisData.forEach(function (yy, index) {
                var seriesdata = {
                  type: 'line',
                  stack: '',
                  name: '',
                  areaStyle: {},
                  emphasis: {
                    focus: 'series'
                  },
                  data: []
                };
                if (that.WidgetDefinition.Stack) {
                  seriesdata.stack = 'total';
                } else {
                  seriesdata.stack = '';
                }
                seriesdata.name = that.WidgetDefinition.YaxisValueData[index];
                var dt = that.WidgetDefinition.VerticalAxis.toUpperCase() + '_' + yy;
                Ydata.filter(function (f) {
                  seriesdata.data.push(f[dt]);
                });
                that.series.push(seriesdata);
              });
              Option = {
                title: that.title,
                tooltip: that.tooltip,
                legend: that.legend,
                grid: that.grid,
                xAxis: that.xAxis,
                yAxis: that.yAxis,
                series: that.series,
                //数据
                dataZoom: that.dataZoom //缩放
              };

              myChart.setOption(Option);
            case 6:
            case "end":
              return _context9.stop();
          }
        }
      }, _callee9);
    }));
    return function chartArea(_x23, _x24, _x25, _x26) {
      return _ref7.apply(this, arguments);
    };
  }();
  var chartAreaData = /*#__PURE__*/function () {
    var _ref8 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee10(rows, data, that, dataname) {
      return _regeneratorRuntime().wrap(function _callee10$(_context10) {
        while (1) {
          switch (_context10.prev = _context10.next) {
            case 0:
              if (JSON.stringify(rows) != '{}') {
                Object.keys(rows).forEach(function (ff) {
                  chartAreaData(rows[ff], data, that, dataname + '.' + ff);
                });
              } else {
                that.xAxis.data.push(dataname);
                Object.keys(data).forEach(function (ff) {
                  if (dataname == ff) {
                    Ydata.push(data[ff]);
                  }
                });
              }
            case 1:
            case "end":
              return _context10.stop();
          }
        }
      }, _callee10);
    }));
    return function chartAreaData(_x27, _x28, _x29, _x30) {
      return _ref8.apply(this, arguments);
    };
  }();
  var numCard = /*#__PURE__*/function () {
    var _ref9 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee11(data, that, myChart) {
      return _regeneratorRuntime().wrap(function _callee11$(_context11) {
        while (1) {
          switch (_context11.prev = _context11.next) {
            case 0:
              console.log(data['_']);
            case 1:
            case "end":
              return _context11.stop();
          }
        }
      }, _callee11);
    }));
    return function numCard(_x31, _x32, _x33) {
      return _ref9.apply(this, arguments);
    };
  }();

  var _hoisted_1 = ["id"];
  function render(_ctx, _cache, $props, $setup, $data, $options) {
    return vue.openBlock(), vue.createElementBlock("div", {
      id: $options.myId
    }, null, 8 /* PROPS */, _hoisted_1);
  }

  script.render = render;
  script.__file = "src/components/myText/chartType.vue";

  /* eslint-disable */
  function myText (Vue) {
    Vue.component(script$1.name, script$1);
    Vue.component(script.name, script);
  }

  function index (Vue) {
    Vue.use(myText);
  }

  return index;

}));
